# Vite + React Single Directory Component (SDC) Generator

This module generates Vite + React app templates within your modules.

> Get started with React and Drupal with minimal effort.

Supports Babel or SWC:

- [@vitejs/plugin-react](https://github.com/vitejs/vite-plugin-react/blob/main/packages/plugin-react/README.md) uses
  [Babel](https://babeljs.io/)
- [@vitejs/plugin-react-swc](https://github.com/vitejs/vite-plugin-react-swc) uses
  [SWC](https://swc.rs/)

Allow you to include testing frameworks, optionally.

- [Vitest](https://vitest.dev/)

## Introduction

The primary use case for the vite_react_generator module is:

- Create an SDC (Single Directory Component) template that contains a React app.

## Requirements

- Drupal 10.3.x

## Installation

Install it as you would normally install a contributed Drupal module.

```shell
drush pm:install vite_react_generator
```

See https://www.drupal.org/node/895232 for further information.

## Usage

```shell
drush generate single-directory-component-vite-react
# or
drush generate sdc-vite-react
```

Follow the prompts.

## Maintainers

Current maintainers:

- George Perry (George) - https://www.drupal.org/u/perrygeorget

Supporting organization:

- The Exploratorium - https://www.exploratorium.edu

## Relate Packages

- [Drupal Code Generator](https://github.com/Chi-teck/drupal-code-generator)
- [Rollup Plugin for Drupal to Extract Interface Translations](https://github.com/Exploratorium/rollup-plugin-drupal-interface-translations)
- [Rollup Plugin for Drupal to Generate Single Directory Components (SDCs)](https://github.com/Exploratorium/rollup-plugin-drupal-sdc-generator)

---

The Exploratorium is a 501(c)(3) nonprofit organization.
Our tax ID #: 94-1696494

https://www.exploratorium.edu
